﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Dapfor.Wpf.Grid.Demo.Internal;
using Dapfor.Wpf.Grid.Demo.ValueConverters;

namespace Dapfor.Wpf.Grid.Demo.Examples.Basics.CustomFilters
{
    /// <summary>
    ///     Interaction logic for CustomFilterDemo.xaml
    /// </summary>
    [Example("Basics", "Custom filters", "Description_CustomFiltersDemo")]
    public partial class CustomFilterDemo : IDisposable
    {
        public CustomFilterDemo()
        {
            InitializeComponent();

            grid.ItemsSource = GetData();
            grid.Headers[0]["sales"].ValueConverter = new Converters.DoubleConverter(0);
            grid.Headers[0]["date"].ValueConverter = new Converters.StringConverter("yyyy-MM-dd");
        }

        public void Dispose()
        {
            
        }

        private ICollection GetData()
        {
            Dictionary<string, IList<string>> manufacturers = new Dictionary<string, IList<string>>();
            Random random = new Random();

            List<string> models = new List<string>();
            models.Add("Golf");
            models.Add("Polo");
            models.Add("Passat");
            models.Add("Touran");
            manufacturers.Add("Volkswagen", models);

            models = new List<string>();
            models.Add("X1");
            models.Add("X3");
            models.Add("X5");
            models.Add("M3 Sedan");
            models.Add("Z4 Roadster");
            manufacturers.Add("BMW", models);

            models = new List<string>();
            models.Add("A-Class");
            models.Add("B-Class");
            models.Add("SLK");
            models.Add("CLS");
            manufacturers.Add("Mercedes", models);


            models = new List<string>();
            models.Add("Scenic");
            models.Add("Duster");
            models.Add("Kangoo");
            models.Add("Clio");
            models.Add("Megane");
            manufacturers.Add("Renault", models);

            models = new List<string>();
            models.Add("308");
            models.Add("407");
            models.Add("5008");
            models.Add("iOn");
            manufacturers.Add("Peugeot", models);

            models = new List<string>();
            models.Add("Panda");
            models.Add("Punto");
            models.Add("500");
            models.Add("Idea");
            manufacturers.Add("Fiat", models);

            models = new List<string>();
            models.Add("Ka");
            models.Add("Fiesta");
            models.Add("Focus");
            models.Add("Fusion");
            manufacturers.Add("Ford", models);


            List<string> keys = new List<string>(manufacturers.Keys);
            ObservableCollection<object[]> bindingList = new ObservableCollection<object[]>();

            //Generate random data
            for (int i = 0; i < 1000; ++i)
            {
                //string manufacturer = GetManufacturer();
                string manufacturer = keys[random.Next(keys.Count)];
                string model = manufacturers[manufacturer][random.Next(manufacturers[manufacturer].Count)];

                object[] data = new object[]
                                    {
                                        manufacturer,
                                        model,
                                        random.Next(1, 50),
                                        (double) random.Next(10000, 25000),
                                        DateTime.Now - TimeSpan.FromDays(2*365) + TimeSpan.FromDays(random.Next(4*365) + 1),
                                        random.NextDouble() + random.Next(99),
                                        random.Next(1, 6)
                                    };

                bindingList.Add(data);
            }
            return bindingList;
        }
    }
}