﻿using System;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using Dapfor.Wpf.Controls;
using Dapfor.Wpf.Grid.Demo.Internal;

namespace Dapfor.Wpf.Grid.Demo.Examples.Basics.HitTests
{
    /// <summary>
    /// Interaction logic for HitTestsDemo.xaml
    /// </summary>
    [Example("Basics", "Hit tests", "Description_HitTestsDemo")]
    public partial class HitTestsDemo
    {
        public HitTestsDemo()
        {
            InitializeComponent();

            PopulateDataObjects();
        }

        private void PopulateDataObjects()
        {
            Random random = new Random();

            //Populate with some data
            for (int i = 0; i < 5; ++i)
            {
                //Populate with top-level items
                RootClass rootObject = new RootClass(i,
                                                     random.NextDouble(),
                                                     random.Next(1000, 20000),
                                                     random.Next() % 2 == 0 ? RootClass.EnumExample.Internal : RootClass.EnumExample.External);
                //Add to the grid
                Row rootRow = grid.Rows.Add(rootObject);
                rootRow.Expanded = true;

                //Add ten children to each root
                for (int j = 0; j < 4; ++j)
                {
                    ChildClass childObject = new ChildClass(i,
                                                            j,
                                                            DateTime.Now + new TimeSpan(1000000000000 * (random.Next() % 1000)),
                                                            random.Next(5),
                                                            new TimeSpan(random.Next()));
                    //Add as a child
                    rootRow.Add(childObject);
                }
            }
        }

        private void UserControl_MouseMove(object sender, System.Windows.Input.MouseEventArgs e)
        {
           

            //TextBlock.TextProperty;
        }


        private void UpdateBindings()
        {

            BindingOperations.GetBindingExpression(tbElement, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbRowIndex, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbRowChildIndex, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbRowDataObject, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbColumnIndex, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbColumnId, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbColumnName, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbCellValue, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbCellValueType, TextBlock.TextProperty).UpdateTarget();
            BindingOperations.GetBindingExpression(tbCellText, TextBlock.TextProperty).UpdateTarget();
        }

        #region Private event handlers

        private void UserControl_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            UpdateBindings();
        }

        private void UserControl_MouseLeave(object sender, MouseEventArgs e)
        {
            UpdateBindings();
        }

        #endregion

    }
}