﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;
using System.Windows.Input;
using Dapfor.Wpf.Controls;

namespace Dapfor.Wpf.Grid.Demo.Examples.Basics.HitTests
{
    class RowInfoConverter : IValueConverter
    {
        public enum InfoType
        {
            Index,
            ChildIndex,
            DataObject,
        }

        public InfoType Info { get; set; }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var grid = (GridControl) value;
            Point position = Mouse.GetPosition(grid);
            Row row = grid.HitTests.RowTest(position);
            if(row != null)
            {
                switch (Info)
                {
                    case InfoType.Index: return row.VisibleIndex;
                    case InfoType.ChildIndex: return row.ChildIndex;
                    case InfoType.DataObject: return row.DataObject;
                }
            }

            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }
}
