﻿using System;
using Dapfor.Wpf.Controls;
using Dapfor.Wpf.Grid.Demo.Internal;

namespace Dapfor.Wpf.Grid.Demo.Examples.Basics.SemiTransparentSelection
{
    /// <summary>
    /// Interaction logic for RealTimeUpdatesDemo.xaml
    /// </summary>
    [Example("Basics", "Semi-transparent selection", "Description_SemiTransparentSelectionDemo")]
    public partial class SemiTransparentSelectionDemo 
    {
        enum State
        {
            Ok,
            PartialOk,
            Nok
        }

        public SemiTransparentSelectionDemo()
        {
            InitializeComponent();

            //Populate the grid with some data
            Random r = new Random();
            for (int i = 0; i < 100; ++i)
            {
                State state = State.Ok;
                if (r.Next(5) == 0) state = State.PartialOk;
                if(r.Next(10) == 0) state = State.Nok;
                
                grid.Rows.Add(new object[] { "Item " + i + ",0", state, "Item " + i + ",2", "Item " + i + ",3", "Item " + i + ",4", "Item " + i + ",5" });
            }

            //Select some rows
            for (int i = 2; i < 12; ++i)
            {
                grid.Rows[i].Selected = true;
            }

            for (int i = 14; i < 17; ++i)
            {
                grid.Rows[i].Selected = true;
            }

            //Focus the row
            grid.Rows[16].Focused = true;
        }

        private void OnResetAppearanceButtonClick(object sender, System.Windows.RoutedEventArgs e)
        {
            grid.ClearValue(GridControl.AppearanceSelectionBackgroundProperty);
            grid.ClearValue(GridControl.AppearanceSelectionBorderProperty);
            grid.ClearValue(GridControl.AppearanceSelectionBorderThicknessProperty);

            grid.ClearValue(GridControl.AppearanceFocusBackgroundProperty);
            grid.ClearValue(GridControl.AppearanceFocusBorderProperty);
            grid.ClearValue(GridControl.AppearanceFocusBorderThicknessProperty);

            grid.ClearValue(GridControl.AppearanceLassoBackgroundProperty);
            grid.ClearValue(GridControl.AppearanceLassoBorderProperty);
            grid.ClearValue(GridControl.AppearanceLassoBorderThicknessProperty);
        }
    }
}
