﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using Dapfor.Wpf.Controls;

namespace Dapfor.Wpf.Grid.Demo.Examples.Miscellaneous.Trading
{
    internal class StateImageConverter : IValueConverter
    {
        public BitmapImage ImageOk { get; set; }
        public BitmapImage ImageNok { get; set; }
        public BitmapImage ImagePartialOk { get; set; }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            Row row = (Row)value;
            if (row != null && row.GroupValue is State)
            {
                switch ((State)row.GroupValue)
                {
                    case State.Ok: return ImageOk;
                    case State.Nok: return ImageNok;
                    case State.PartialOk: return ImagePartialOk;
                }
            }
            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }
}