﻿using System;
using System.ComponentModel;
using Dapfor.Wpf.Data;

namespace Dapfor.Wpf.Grid.Demo.Examples.Performance.FilterPerformance
{
    internal class DataObjectCollection : ThreadSafeBindingList<DataObject>
    {
        private readonly Random _r = new Random();
        private int _desiredCount;

        public int DesiredCount
        {
            get { return _desiredCount; }
            set
            {
                int newCount = Math.Max(0, value);
                if (newCount != _desiredCount)
                {
                    _desiredCount = newCount;
                    //Fit collection to the desired size
                    if (_desiredCount < Count)
                    {
                        //Remove objects
                        int toRemove = Count - _desiredCount;
                        for (int i = 0; i < toRemove; ++i)
                        {
                            RemoveAt(Count - 1);
                        }
                    }
                    else if (_desiredCount > Count)
                    {
                        //Add new objects
                        int toAdd = _desiredCount - Count;
                        for (int i = 0; i < toAdd; ++i)
                        {
                            Add(new DataObject(_r));
                        }
                    }
                }
            }
        }
    }
}