﻿using System;
using System.ComponentModel;
using Dapfor.Wpf.Controls;
using Dapfor.Wpf.Data;

namespace Dapfor.Wpf.Grid.Demo.Examples.Performance.RealTimeSorting
{
    /// <summary>
    /// The objects of this class will be displayed in the <see cref="GridControl"/>. 
    /// </summary>
    public class DataObject : INotifyPropertyChanged
    {
        static readonly Random _r = new Random();
        #region Fields

        #endregion

        #region Public properties

        public DataObject(int minValue, int maxValue)
        {
            Value0 = _r.Next(minValue, maxValue);
            Value1 = _r.Next(minValue, maxValue);
            Value2 = _r.Next(minValue, maxValue);
            Value3 = _r.Next(minValue, maxValue);
            Value4 = _r.Next(minValue, maxValue);
            Value5 = _r.Next(minValue, maxValue);
            Value6 = _r.Next(minValue, maxValue);
            Value7 = _r.Next(minValue, maxValue);
            Value8 = _r.Next(minValue, maxValue);
            Value9 = _r.Next(minValue, maxValue);
        }

        [Field("Id0")]
        public int Value0 { get; private set; }

        [Field("Id1")]
        public int Value1 { get; private set; }

        [Field("Id2")]
        public int Value2 { get; private set; }

        [Field("Id3")]
        public int Value3 { get; private set; }

        [Field("Id4")]
        public int Value4 { get; private set; }

        [Field("Id5")]
        public int Value5 { get; private set; }

        [Field("Id6")]
        public int Value6 { get; private set; }

        [Field("Id7")]
        public int Value7 { get; private set; }

        [Field("Id8")]
        public int Value8 { get; private set; }

        [Field("Id9")]
        public int Value9 { get; private set; }

        #endregion

        public void RandomUpdate(int min, int max)
        {
            int newValue = _r.Next(min, max);

            switch (_r.Next(10))
            {
                case 0: Value0 = newValue; FirePropertyChanged("Id0"); break;
                case 1: Value1 = newValue; FirePropertyChanged("Id1"); break;
                case 2: Value2 = newValue; FirePropertyChanged("Id2"); break;
                case 3: Value3 = newValue; FirePropertyChanged("Id3"); break;
                case 4: Value4 = newValue; FirePropertyChanged("Id4"); break;
                case 5: Value5 = newValue; FirePropertyChanged("Id5"); break;
                case 6: Value6 = newValue; FirePropertyChanged("Id6"); break;
                case 7: Value7 = newValue; FirePropertyChanged("Id7"); break;
                case 8: Value8 = newValue; FirePropertyChanged("Id8"); break;
                case 9: Value9 = newValue; FirePropertyChanged("Id9"); break;
            }
        }

        private void FirePropertyChanged(string field)
        {
            if(PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(field));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
