﻿using System;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Markup;
using Dapfor.Wpf.Grid.Demo.Internal;
using Microsoft.Win32;

namespace Dapfor.Wpf.Grid.Demo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Internal.Examples.ExampleGroups[0].Examples[0].IsSelected = true;
        }

        private void OnExampleChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            e.Handled = true;
            var example = e.NewValue as Example;
            Control control = example != null ? example.CreateControl() : null;
            var prevControl = contentHolder.Content as IDisposable;

            BindingOperations.ClearBinding(contentHolder, ContentProperty);
            contentHolder.Content = control;
            tbDescription.Text = example != null ? example.Description : string.Empty;
            
            //TODO: look for for example file
            exampleHelp.Visibility = Visibility.Collapsed;

            if(control != null)
            {
                control.Focus();
            }
            if(prevControl != null)
            {
                prevControl.Dispose();
            }
        }

        private void exampleHelp_Click(object sender, RoutedEventArgs e)
        {
         //   flipPanel.FrontVisible = !flipPanel.FrontVisible;

            var example = exampleTree.SelectedItem as Example;
            if(example != null)
            {
                
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                OpenFileDialog openDialog = new OpenFileDialog();
                openDialog.Filter = "Themes|*.xaml|All|*.*";
                if (openDialog.ShowDialog().Value)
                {
                    if(!string.IsNullOrEmpty(openDialog.FileName)&& File.Exists(openDialog.FileName))
                    {
                        using (FileStream fs = new FileStream(openDialog.FileName, FileMode.Open))
                        {
                            ResourceDictionary dico = (ResourceDictionary)XamlReader.Load(fs);
                            Application.Current.Resources.MergedDictionaries.Clear();
                            Application.Current.Resources.MergedDictionaries.Add(dico);
                            Control control = contentHolder.Content as Control;
                            if(control != null)
                            {
                                control.InvalidateMeasure();
                            }
                        }        
                    }
                  
                }
            }
            catch (Exception exception)
            {
                MessageBox.Show(exception.ToString(), "Can't load dictionary", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
    }
}
