﻿using System.Collections;
using System.ComponentModel;

namespace Dapfor.Wpf.Grid.Demo.Utils
{
    /// <summary>
    /// Represents a collection of multiple data sources
    /// </summary>
    public class DataSourceCollection : IListSource
    {
        private readonly IList _listSource;

        public DataSourceCollection(IList listSource)
        {
            _listSource = listSource != null ? new ArrayList(listSource) : new ArrayList();
        }

        #region IListSource Members

        public IList GetList()
        {
            return _listSource;
        }

        public bool ContainsListCollection
        {
            get { return true; }
        }

        #endregion
    }
}