﻿using System;
using System.Globalization;
using System.Windows.Data;

namespace Dapfor.Wpf.Grid.Demo.ValueConverters
{
    /// <summary>
    /// Converts double values to text and vice versa.
    /// </summary>
    public class DoubleValueConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value.ToString();
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var text = (string) value;
            double result = !string.IsNullOrEmpty(text) ? double.Parse(text) : 0;
            return result;

            
        }

        #endregion
    }
}